diff --git a/fftools/ffmpeg_demux.c b/fftools/ffmpeg_demux.c
index b312ff4922..aad5215d94 100644
--- a/fftools/ffmpeg_demux.c
+++ b/fftools/ffmpeg_demux.c
@@ -480,28 +480,6 @@ static int input_packet_process(Demuxer *d, DemuxMsg *msg, AVPacket *src)
     ds->data_size += pkt->size;
     ds->nb_packets++;
 
-    /* add the stream-global side data to the first packet */
-    if (ds->nb_packets == 1) {
-        for (int i = 0; i < ist->st->codecpar->nb_side_data; i++) {
-            AVPacketSideData *src_sd = &ist->st->codecpar->side_data[i];
-            uint8_t *dst_data;
-
-            if (src_sd->type == AV_PKT_DATA_DISPLAYMATRIX)
-                continue;
-
-            if (av_packet_get_side_data(pkt, src_sd->type, NULL))
-                continue;
-
-            dst_data = av_packet_new_side_data(pkt, src_sd->type, src_sd->size);
-            if (!dst_data) {
-                ret = AVERROR(ENOMEM);
-                goto fail;
-            }
-
-            memcpy(dst_data, src_sd->data, src_sd->size);
-        }
-    }
-
     if (debug_ts) {
         av_log(NULL, AV_LOG_INFO, "demuxer+ffmpeg -> ist_index:%d:%d type:%s pkt_pts:%s pkt_pts_time:%s pkt_dts:%s pkt_dts_time:%s duration:%s duration_time:%s off:%s off_time:%s\n",
                f->index, pkt->stream_index,
diff --git a/tests/ref/fate/autorotate b/tests/ref/fate/autorotate
index dff628bbff..2aa29fafa7 100644
--- a/tests/ref/fate/autorotate
+++ b/tests/ref/fate/autorotate
@@ -11,8 +11,8 @@
 #codec_id 1: ac3
 #sample_rate 1: 44100
 #channel_layout_name 1: mono
-0,       -512,          0,      512,     6997, 0x55c700f6, S=1,       40
-1,       -256,       -256,     1536,      416, 0x92ddc529, S=2,       10,        4
+0,       -512,          0,      512,     6997, 0x55c700f6
+1,       -256,       -256,     1536,      416, 0x92ddc529, S=1,       10
 0,          0,        512,      512,     4847, 0xe74f522e, F=0x0
 1,       1280,       1280,     1536,      418, 0x0a7fcd2d
 0,        512,       1024,      512,     5281, 0xbd4a5dac, F=0x0
diff --git a/tests/ref/fate/copy-trac3074 b/tests/ref/fate/copy-trac3074
index b6d23f8c1c..53ba27e920 100644
--- a/tests/ref/fate/copy-trac3074
+++ b/tests/ref/fate/copy-trac3074
@@ -5,7 +5,7 @@
 #codec_id 0: eac3
 #sample_rate 0: 48000
 #channel_layout_name 0: stereo
-0,          0,          0,     1536,      512, 0x2beaf79f, S=1,        4
+0,          0,          0,     1536,      512, 0x2beaf79f
 0,       1536,       1536,     1536,      512, 0x29ddf9d6
 0,       3072,       3072,     1536,      512, 0xba0afa79
 0,       4608,       4608,     1536,      512, 0xe019f394
diff --git a/tests/ref/fate/matroska-avoid-negative-ts b/tests/ref/fate/matroska-avoid-negative-ts
index 05821cbf09..3ba289c6e6 100644
--- a/tests/ref/fate/matroska-avoid-negative-ts
+++ b/tests/ref/fate/matroska-avoid-negative-ts
@@ -11,7 +11,7 @@ dede1d72a28c7eb0a849acf230b08247 *tests/data/fate/matroska-avoid-negative-ts.mat
 #codec_id 1: mp3
 #sample_rate 1: 44100
 #channel_layout_name 1: mono
-0,        -37,         43,       40,     9156, 0xe5bd034a, S=1,       40
+0,        -37,         43,       40,     9156, 0xe5bd034a
 1,          0,          0,       26,      417, 0x7198c15e
 0,          3,          3,       40,     1740, 0x29ac4480, F=0x0
 1,         26,         26,       26,      417, 0x3c67c32d
diff --git a/tests/ref/fate/matroska-dovi-write-config7 b/tests/ref/fate/matroska-dovi-write-config7
index aaeeb34751..dc5b73a44e 100644
--- a/tests/ref/fate/matroska-dovi-write-config7
+++ b/tests/ref/fate/matroska-dovi-write-config7
@@ -13,7 +13,7 @@
 #dimensions 1: 1920x1080
 #sar 1: 0/1
 0,        -83,          0,       41,      699, 0x728548f1
-1,        -83,          0,       41,     1085, 0xfb2dba82, S=1,        8
+1,        -83,          0,       41,     1085, 0xfb2dba82
 0,        -42,        167,       41,       95, 0xc0312044, F=0x0
 1,        -42,        167,       41,      481, 0xf23f91d5, F=0x0
 0,          0,         83,       41,       99, 0x5e0a2221, F=0x0
diff --git a/tests/ref/fate/matroska-dovi-write-config8 b/tests/ref/fate/matroska-dovi-write-config8
index 55fe191047..472cbed708 100644
--- a/tests/ref/fate/matroska-dovi-write-config8
+++ b/tests/ref/fate/matroska-dovi-write-config8
@@ -12,7 +12,7 @@
 #codec_id 1: aac
 #sample_rate 1: 44100
 #channel_layout_name 1: stereo
-0,        -67,          0,       33,    63375, 0xc76606ab, S=1,        8
+0,        -67,          0,       33,    63375, 0xc76606ab
 0,        -34,        133,       33,    46706, 0x0e08a7e5, F=0x0
 0,          0,         67,       33,    29766, 0x753c031a, F=0x0
 1,          0,          0,       23,        6, 0x031e0108
diff --git a/tests/ref/fate/matroska-encoding-delay b/tests/ref/fate/matroska-encoding-delay
index d2ff2d07be..ee1989cbcb 100644
--- a/tests/ref/fate/matroska-encoding-delay
+++ b/tests/ref/fate/matroska-encoding-delay
@@ -12,7 +12,7 @@
 #sample_rate 1: 48000
 #channel_layout_name 1: stereo
 1,        -10,        -10,       24,     1152, 0x724077b8
-0,          0,          0,       40,   237628, 0xeff25579, S=1,       40
+0,          0,          0,       40,   237628, 0xeff25579
 1,         14,         14,       24,     1152, 0x80625572
 1,         38,         38,       24,     1152, 0x7d7f4dce
 0,         40,         40,       40,   238066, 0xb2265f41
diff --git a/tests/ref/fate/matroska-mastering-display-metadata b/tests/ref/fate/matroska-mastering-display-metadata
index 3726469213..53f84c1793 100644
--- a/tests/ref/fate/matroska-mastering-display-metadata
+++ b/tests/ref/fate/matroska-mastering-display-metadata
@@ -22,9 +22,9 @@
 #codec_id 3: ffv1
 #dimensions 3: 1280x720
 #sar 3: 1/1
-0,          0,          0,       16,    57008, 0x43416399, S=2,        8,       88
+0,          0,          0,       16,    57008, 0x43416399
 1,          0,          0,       16,     2403, 0xaa818522
-3,          0,          0,       16,   274117, 0xc439610f, S=2,        8,       88
+3,          0,          0,       16,   274117, 0xc439610f
 0,         17,         17,       16,    57248, 0xa06cd7b5
 1,         17,         17,       16,     2403, 0xe1a991e5
 2,         17,         17,       16,     1602, 0x5d868171
diff --git a/tests/ref/fate/matroska-spherical-mono-remux b/tests/ref/fate/matroska-spherical-mono-remux
index e9904b2c92..6fcda14822 100644
--- a/tests/ref/fate/matroska-spherical-mono-remux
+++ b/tests/ref/fate/matroska-spherical-mono-remux
@@ -12,8 +12,8 @@ fddfea5f05a7a9a0d187df9a72900055 *tests/data/fate/matroska-spherical-mono-remux.
 #codec_id 1: h264
 #dimensions 1: 1920x1080
 #sar 1: 0/1
-0,        -80,          0,       40,    69118, 0x73cb52f0, S=2,       12,       36
-1,        -80,          0,       40,    69118, 0x73cb52f0, S=2,       12,       36
+0,        -80,          0,       40,    69118, 0x73cb52f0
+1,        -80,          0,       40,    69118, 0x73cb52f0
 0,        -40,        160,       40,     1103, 0x082a059f, F=0x0
 1,        -40,        160,       40,     1103, 0x082a059f, F=0x0
 [STREAM]
diff --git a/tests/ref/fate/matroska-stereo_mode b/tests/ref/fate/matroska-stereo_mode
index 5c36a6d666..739b789fea 100644
--- a/tests/ref/fate/matroska-stereo_mode
+++ b/tests/ref/fate/matroska-stereo_mode
@@ -43,10 +43,10 @@ a7a220a77001e81685ec807ce5ac3bc6 *tests/data/fate/matroska-stereo_mode.matroska
 #dimensions 6: 512x512
 #sar 6: 2/1
 0,          0,          0,     1000,   206173, 0x95af7455
-1,          0,          0,     1000,   206173, 0x95af7455, S=1,       12
-2,          0,          0,     1000,   206173, 0x95af7455, S=1,       12
-3,          0,          0,     1000,   206173, 0x95af7455, S=1,       12
-4,          0,          0,     1000,   206173, 0x95af7455, S=1,       12
+1,          0,          0,     1000,   206173, 0x95af7455
+2,          0,          0,     1000,   206173, 0x95af7455
+3,          0,          0,     1000,   206173, 0x95af7455
+4,          0,          0,     1000,   206173, 0x95af7455
 5,          0,          0,     1000,   206173, 0x95af7455
 6,          0,          0,     1000,   206173, 0x95af7455
 0,       1000,       1000,     1000,       36, 0x34891010, F=0x0
diff --git a/tests/ref/fate/matroska-vp8-alpha-remux b/tests/ref/fate/matroska-vp8-alpha-remux
index eba3ffb77a..8117325433 100644
--- a/tests/ref/fate/matroska-vp8-alpha-remux
+++ b/tests/ref/fate/matroska-vp8-alpha-remux
@@ -5,7 +5,7 @@
 #codec_id 0: vp8
 #dimensions 0: 320x213
 #sar 0: 1/1
-0,          0,          0,       33,     2108, 0x59b92a34, S=2,     1900,       12
+0,          0,          0,       33,     2108, 0x59b92a34, S=1,     1900
 0,         32,         32,       33,      142, 0x2f2a3fed, F=0x0, S=1,      160
 0,         65,         65,       33,      157, 0x17804767, F=0x0, S=1,      209
 0,         99,         99,       33,      206, 0x537262ca, F=0x0, S=1,      317
diff --git a/tests/ref/fate/mov-mp4-disposition-mpegts-remux b/tests/ref/fate/mov-mp4-disposition-mpegts-remux
index efef043074..ba419843dc 100644
--- a/tests/ref/fate/mov-mp4-disposition-mpegts-remux
+++ b/tests/ref/fate/mov-mp4-disposition-mpegts-remux
@@ -10,9 +10,9 @@ adb3b95c07a5f3e0c86641dd62f01dae *tests/data/fate/mov-mp4-disposition-mpegts-rem
 #codec_id 1: ac3
 #sample_rate 1: 48000
 #channel_layout_name 1: stereo
-1,          0,          0,     1536,      768, 0xa63778d4, S=1,        4
+1,          0,          0,     1536,      768, 0xa63778d4
 1,       1536,       1536,     1536,      768, 0x7d577f3f
-0,       3072,       3072,     1536,      768, 0xc2867884, S=1,        4
+0,       3072,       3072,     1536,      768, 0xc2867884
 1,       3072,       3072,     1536,      768, 0xd86b7c8f
 0,       4608,       4608,     1536,      690, 0xa2714bf3
 1,       4608,       4608,     1536,      626, 0x09f4382f
diff --git a/tests/ref/fate/mxf-d10-user-comments b/tests/ref/fate/mxf-d10-user-comments
index 1b59beec7c..ccfdc83f11 100644
--- a/tests/ref/fate/mxf-d10-user-comments
+++ b/tests/ref/fate/mxf-d10-user-comments
@@ -6,7 +6,7 @@
 #codec_id 0: mpeg2video
 #dimensions 0: 1280x720
 #sar 0: 3/4
-0,         -1,          0,        1,   150000, 0x0547870d, S=1,       40
+0,         -1,          0,        1,   150000, 0x0547870d
 0,          0,          1,        1,   150000, 0xe80a1612, F=0x0
 0,          1,          2,        1,   150000, 0xc5c50e2f, F=0x0
 0,          2,          3,        1,   150000, 0x51e28a04, F=0x0
diff --git a/tests/ref/fate/mxf-remux-applehdr10 b/tests/ref/fate/mxf-remux-applehdr10
index 29e0e03a72..9fbf8b60c7 100644
--- a/tests/ref/fate/mxf-remux-applehdr10
+++ b/tests/ref/fate/mxf-remux-applehdr10
@@ -10,7 +10,7 @@
 #codec_id 1: pcm_s24le
 #sample_rate 1: 48000
 #channel_layout_name 1: mono
-0,          0,          0,        1,    57008, 0x43416399, S=1,       88
+0,          0,          0,        1,    57008, 0x43416399
 1,          0,          0,      801,     2403, 0x00000000
 0,          1,          1,        1,    57248, 0xa06cd7b5
 1,        801,        801,      801,     2403, 0x00000000
diff --git a/tests/ref/fate/vp9-superframe-bsf b/tests/ref/fate/vp9-superframe-bsf
index d7985c6973..485644dfb2 100644
--- a/tests/ref/fate/vp9-superframe-bsf
+++ b/tests/ref/fate/vp9-superframe-bsf
@@ -3,7 +3,7 @@
 #codec_id 0: vp9
 #dimensions 0: 352x288
 #sar 0: 1/1
-0,          0,          0,       33,     6958, 0x38e58ee6, S=1,       12
+0,          0,          0,       33,     6958, 0x38e58ee6
 0,         33,         33,       33,      852, 0x3edf9ed0, F=0x0
 0,         66,         66,       33,       27, 0x62d007e5, F=0x0
 0,        100,        100,       33,       25, 0x51980749, F=0x0